import * as React from 'react';
import { ExpansionPanel } from './ExpansionPanel';
import { IgrOnExpandedEventArgs } from './igr-on-expanded-event-args';
import { IgrOnCollapsedEventArgs } from './igr-on-collapsed-event-args';
export declare class IgrExpansionPanel extends React.Component<IIgrExpansionPanelProps> {
    private _height;
    private _width;
    private _initialized;
    private _elRef;
    private _headerRef;
    private _contentAreaOuterRef;
    private _contentAreaInnerRef;
    private _reactRenderer;
    private _implementation;
    private _portalManager;
    height: string;
    width: string;
    private _getMainRef;
    private _getHeaderRef;
    private _getContentAreaOuterRef;
    private _getContentAreaInnerRef;
    private verifyReferences;
    render(): React.DetailedReactHTMLElement<{
        ref: (ref: any) => void;
        className: string;
        children: any[];
    }, any>;
    private requestRender;
    constructor(props: IIgrExpansionPanelProps);
    shouldComponentUpdate(nextProps: any, nextState: any): boolean;
    protected initializeProperties(): void;
    updateStyle(): void;
    componentWillUnmount(): void;
    componentDidMount(): void;
    initializeContent(): void;
    protected createImplementation(): ExpansionPanel;
    readonly i: ExpansionPanel;
    /**
 * Gets / sets the caption to display in the header area.
*/
    caption: string;
    /**
     * Gets or sets the color to use for the header caption text.
    */
    captionTextColor: string;
    /**
     * Gets or sets the color to use for the actual header caption text.
    */
    actualCaptionTextColor: string;
    /**
     * Gets or sets the color to use for the header caption text when the panel is collapsed.
    */
    captionCollapsedTextColor: string;
    /**
     * Gets or sets the color to use for the header caption text when the panel is expanded.
    */
    captionExpandedTextColor: string;
    /**
     * Gets / sets the description to display in the header area.
    */
    description: string;
    /**
     * Gets or sets the color to use for the header description text.
    */
    descriptionTextColor: string;
    /**
     * Gets or sets the color to use for the actual header description text.
    */
    actualDescriptionTextColor: string;
    /**
     * Gets or sets the color to use for the header description text when the panel is collapsed.
    */
    descriptionCollapsedTextColor: string;
    /**
     * Gets or sets the color to use for the header description text when the panel is expanded.
    */
    descriptionExpandedTextColor: string;
    /**
     * Gets or sets the elevation to use for the button regardless of type.
    */
    elevation: number;
    /**
     * Gets or sets the elevation of the border shadow
    */
    actualElevation: number;
    /**
     * Gets / sets the expanded state of the panel.
    */
    expanded: boolean;
    /**
     * Gets or sets the color to use for the background of the header.
    */
    headerBackgroundColor: string;
    /**
     * Gets or sets the color to use for the actual background of the header.
    */
    actualHeaderBackgroundColor: string;
    /**
     * Gets or sets the color to use for the background of the header when the panel is expanded.
    */
    headerCollapsedBackgroundColor: string;
    /**
     * Gets or sets the color to use for the background of the header when the panel is expanded.
    */
    headerExpandedBackgroundColor: string;
    /**
     * Gets or sets the color to use for the check mark when the checkbox is checked.
    */
    actualUmbraShadowColor: string;
    /**
     * Gets or sets the color to use for the check mark when the checkbox is checked.
    */
    actualPenumbraShadowColor: string;
    /**
     * Gets or sets the color to use for the check mark when the checkbox is checked.
    */
    actualAmbientShadowColor: string;
    findByName(name: string): any;
    protected __p: string;
    protected _hasUserValues: Set<string>;
    protected readonly hasUserValues: Set<string>;
    protected __m(propertyName: string): void;
    protected _stylingContainer: any;
    protected _stylingParent: any;
    protected _inStyling: boolean;
    protected _styling(container: any, component: any, parent?: any): void;
    /**
 * Collapses the contents of the expansion panel.

*/
    collapse(): void;
    /**
     * Expands the contents of the expansion panel.
    
    */
    expand(): void;
    /**
     * Toggles the expanded state of the expansion panel.
    
    */
    toggle(): void;
    private _onCollapsed;
    private _onCollapsed_wrapped;
    /**
     * Fires when the expansion panel is collapsed.
    */
    onCollapsed: (s: IgrExpansionPanel, e: IgrOnCollapsedEventArgs) => void;
    private _onExpanded;
    private _onExpanded_wrapped;
    onExpanded: (s: IgrExpansionPanel, e: IgrOnExpandedEventArgs) => void;
}
export interface IIgrExpansionPanelProps {
    width?: string;
    height?: string;
    /**
 * Gets / sets the caption to display in the header area.
*/
    caption?: string;
    /**
     * Gets or sets the color to use for the header caption text.
    */
    captionTextColor?: string;
    /**
     * Gets or sets the color to use for the actual header caption text.
    */
    actualCaptionTextColor?: string;
    /**
     * Gets or sets the color to use for the header caption text when the panel is collapsed.
    */
    captionCollapsedTextColor?: string;
    /**
     * Gets or sets the color to use for the header caption text when the panel is expanded.
    */
    captionExpandedTextColor?: string;
    /**
     * Gets / sets the description to display in the header area.
    */
    description?: string;
    /**
     * Gets or sets the color to use for the header description text.
    */
    descriptionTextColor?: string;
    /**
     * Gets or sets the color to use for the actual header description text.
    */
    actualDescriptionTextColor?: string;
    /**
     * Gets or sets the color to use for the header description text when the panel is collapsed.
    */
    descriptionCollapsedTextColor?: string;
    /**
     * Gets or sets the color to use for the header description text when the panel is expanded.
    */
    descriptionExpandedTextColor?: string;
    /**
     * Gets or sets the elevation to use for the button regardless of type.
    */
    elevation?: number | string;
    /**
     * Gets or sets the elevation of the border shadow
    */
    actualElevation?: number | string;
    /**
     * Gets / sets the expanded state of the panel.
    */
    expanded?: boolean | string;
    /**
     * Gets or sets the color to use for the background of the header.
    */
    headerBackgroundColor?: string;
    /**
     * Gets or sets the color to use for the actual background of the header.
    */
    actualHeaderBackgroundColor?: string;
    /**
     * Gets or sets the color to use for the background of the header when the panel is expanded.
    */
    headerCollapsedBackgroundColor?: string;
    /**
     * Gets or sets the color to use for the background of the header when the panel is expanded.
    */
    headerExpandedBackgroundColor?: string;
    /**
     * Gets or sets the color to use for the check mark when the checkbox is checked.
    */
    actualUmbraShadowColor?: string;
    /**
     * Gets or sets the color to use for the check mark when the checkbox is checked.
    */
    actualPenumbraShadowColor?: string;
    /**
     * Gets or sets the color to use for the check mark when the checkbox is checked.
    */
    actualAmbientShadowColor?: string;
    /**
 * Fires when the expansion panel is collapsed.
*/
    onCollapsed?: (s: IgrExpansionPanel, e: IgrOnCollapsedEventArgs) => void;
    onExpanded?: (s: IgrExpansionPanel, e: IgrOnExpandedEventArgs) => void;
}
